import React from 'react';

export const RequiredInput = (props: {
  value: any;
  label: string;
  placeHolder: string;
  type: string;
  errorText: string;
  validate: (value: any) => boolean;
  onChange: (value: any) => void;
}) => {
  const [isValid, setIsValid] = React.useState<boolean>(true);

  return (
    <div className="form-control w-full ">
      <label className="label">
        <span className="label-text">{props.label}</span>
        {isValid ? null : <span className="label-text-alt text-error">{props.errorText}</span>}
      </label>
      <input
        type={props.type}
        placeholder={props.placeHolder}
        className={`input input-bordered w-full  ${isValid ? '' : 'input-error'}`}
        value={props.value}
        onChange={(event) => {
          setIsValid(props.validate(event.target.value));
          props.onChange(event.target.value);
        }}
        required
      />
    </div>
  );
};
